import os
import json
from openai import OpenAI

# Load system message
with open("library_babel_system_message", "r") as file:
    system_message = file.read()

# open the library_of_babel.txt file
with open("library_of_babel.txt", "r") as file:
    library_of_babel = file.read()

# OpenAI API setup
client = OpenAI(api_key=os.getenv("OPENAI_API_KEY") or "YOUR API KEY HERE")


messages = [
    {"role": "system", "content": json.dumps(system_message)},
    {"role": "user", "content": f"document you are working on: {library_of_babel}"}
]

try:
    response = client.chat.completions.create(
        model="gpt-4-1106-preview",
        response_format={"type": "json_object"},
        stream=True,
        messages=messages
    )

    responses = ''
    # Process and save the response
    # Process and save the response
    for chunk in response:
        if chunk.choices[0].delta.content:
            text_chunk = chunk.choices[0].delta.content
            print(text_chunk, end="", flush=True)  # Print each chunk as it arrives
            responses += str(text_chunk)

    # Parse the final responses string as JSON
    json_responses = json.loads(responses)

    # Save the final response to a file
    with open("library_of_babel.json", "w") as file:
        json.dump(json_responses, file, indent=4)

    
except Exception as e:
    print(f"Error: {e}")

