# Variables and Basic Data Types
"""
In Python, a variable is a symbolic name that is a reference or pointer to an object. Once an object is assigned to a variable, you can refer to the object by that name. Python is a dynamically typed language, which means that the Python interpreter infers the type of an object at runtime, and you do not need to explicitly declare the type of a variable. The basic data types in Python include integers (int), floating-point numbers (float), strings (str), and booleans (bool). An integer is a whole number without a decimal point. A float represents a number with a decimal point. A string is a sequence of characters, typically used to represent text. A boolean is a logical value that can either be True or False.
"""

# Example: # Example of an integer assignment
x = 10
print(x)  # Output: 10
# Example: # Example of a float assignment
y = 3.14
print(y)  # Output: 3.14
# Example: # Example of a string assignment
name = 'Alice'
print(name)  # Output: Alice
# Example: # Example of a boolean assignment
is_student = True
print(is_student)  # Output: True
# Example: # Variables can change types through reassignment
z = 1  # `z` is initially an integer
print(type(z))  # Output: <class 'int'>
z = 'hello'  # `z` is now a string
print(type(z))  # Output: <class 'str'>
# Example: # Python supports chaining assignment
a = b = c = 20
print(a, b, c)  # Output: 20 20 20
# Exercise: 1. Create an integer variable named 'age' and assign the value 25 to it. Then print its type using `type()` function.
# Exercise: 2. Create a float variable called 'price' and assign any decimal number to it. Print its value.
# Exercise: 3. Create two string variables: 'first_name' and 'last_name' and assign your first and last name to them respectively. Then print the full name by concatenating them with a space in between.
# Exercise: 4. Create a boolean variable 'has_license' and set it to False. Later in your program, update it to True and print its value.
# Exercise: 5. Take any variable assigned with a number and use the `+=` operator to increase its value by any amount and print the result.
# Additional Resource: https://docs.python.org/3/tutorial/introduction.html#using-python-as-a-calculator
# Additional Resource: https://realpython.com/python-variables/
# Additional Resource: https://www.learnpython.org/en/Variables_and_Types
# Additional Resource: https://www.w3schools.com/python/python_variables.asp