# Control Flow (if, else, loops)
"""
Control flow in Python refers to the order in which the program's code executes. The control flow of a program is directed using conditional statements, loops, and function calls. Python uses common control flow statements known as 'if', 'else', and 'elif' (short for else if) to execute code conditionally. Additionally, loops like 'for' and 'while' are used to execute a block of code repeatedly for a set number of times or until a particular condition is met.
"""

# Example: # Example of if statement
x = 10
if x > 5:
    print('x is greater than 5')

# Example: # Example of if-else statement
x = 2
if x > 5:
    print('x is greater than 5')
else:
    print('x is less than or equal to 5')

# Example: # Example of if-elif-else statement
x = 10
if x > 10:
    print('x is greater than 10')
elif x == 10:
    print('x is 10')
else:
    print('x is less than 10')

# Example: # Example of for loop
for i in range(5):
    print('i is', i)

# Example: # Example of nested loops
for i in range(3):
    for j in range(2):
        print('i is', i, 'and j is', j)

# Example: # Example of a while loop
i = 0
while i < 5:
    print('i is', i)
    i += 1

# Exercise: 1. Write an if-else statement to check if a number is odd or even.
# Exercise: 2. Create a for loop that prints out numbers from 1 to 10 inclusive.
# Exercise: 3. Write an if-elif-else chain that prints 'child' if age < 13, 'teenager' if age is between 13 and 17, and 'adult' if age is 18 or above.
# Exercise: 4. Use a nested for loop to generate a multiplication table for numbers 1 through 5.
# Exercise: 5. Use a while loop to reverse a given string.
# Additional Resource: https://docs.python.org/3/tutorial/controlflow.html
# Additional Resource: https://www.w3schools.com/python/python_conditions.asp
# Additional Resource: https://realpython.com/python-conditional-statements/
# Additional Resource: https://realpython.com/python-for-loop/
# Additional Resource: https://www.learnpython.org/en/Loops