# Exception Handling
"""
Exception handling in Python is a mechanism that is used to handle runtime errors. It allows a program to continue execution even if an exception occurs. Exceptions are essentially events that can disrupt the normal flow of a program and are typically generated by errors. In Python, exceptions are objects that represent an error or unusual condition that has arisen during the execution of a piece of code. Exception handling uses the keywords 'try', 'except', 'else', 'finally', and 'raise' to handle exceptions and take corrective actions without stopping the whole program. The 'try' block is used to wrap code that might generate an exception, while 'except' blocks catch and handle specific or general exceptions. The 'else' block can be used to execute code when the try block doesn't raise an exception. The 'finally' block is optional and if present, gets executed regardless of whether an exception has been raised or not, and is typically used for cleanup tasks. The 'raise' keyword is used to force an exception to occur, which can be useful for triggering custom exceptions when conditions warrant it.
"""

# Example: # Example 1: Basic try-except structure
# Example: try:
# Example:     number = int(input('Enter a number: '))
# Example: except ValueError:
# Example:     print('That was not a valid number!')
# Example: # Example 2: Handling multiple exceptions
# Example: try:
# Example:     number = int(input('Enter a number: '))
# Example:     result = 10 / number
# Example: except ValueError:
# Example:     print('Please enter a valid integer.')
# Example: except ZeroDivisionError:
# Example:     print('Attempted to divide by zero.')
# Example: # Example 3: Using else block
# Example: try:
# Example:     number = int(input('Enter a number: '))
# Example: except ValueError:
# Example:     print('That was not a valid number!')
# Example: else:
# Example:     print(f'You entered the number {number}.')
# Example: # Example 4: Using finally block
# Example: try:
# Example:     number = int(input('Enter a number: '))
# Example: except ValueError:
# Example:     print('That was not a valid number!')
# Example: finally:
# Example:     print('This block is executed no matter what!')
# Example: # Example 5: Raising an exception
# Example: x = 10
# Example: if x > 5:
# Example:     raise ValueError('x should not exceed 5. The value of x was: {}'.format(x))
# Exercise: 1. Write a function called divide(x, y) that returns the result of dividing x by y. Handle the possible ZeroDivisionError that occurs when y is zero by returning 'Cannot divide by zero!'.
# Exercise: 2. Create a program that asks the user for a filename, attempts to open that file and read its contents, and catches a FileNotFoundError to inform the user if the file does not exist.
# Exercise: 3. Modify the following code to include an 'else' block that prints 'No exceptions occurred.' when no exceptions are raised: 
try:
    print('Inside the try block')
except Exception as e:
    print('Caught an exception: ' + str(e))
# Exercise: 4. Write a try-except block to catch an IndexError for the following list: 
my_list = [1, 2, 3]
index_to_access = 5
# Access an element by index and handle the potential IndexError.
# Exercise: 5. Define a custom exception called 'CustomError', raise it in your code, and then handle it in a try-except block.
# Additional Resource: https://docs.python.org/3/tutorial/errors.html
# Additional Resource: https://realpython.com/python-exceptions/
# Additional Resource: https://docs.python.org/3/library/exceptions.html
# Additional Resource: https://www.programiz.com/python-programming/exception-handling
# Additional Resource: https://www.geeksforgeeks.org/python-exception-handling/