# Libraries and Frameworks (NumPy, Pandas)
"""
In Python, libraries and frameworks are collections of modules and packages that provide pre-written functionality to streamline the development of your applications. Two of the most popular libraries for data manipulation and analysis are NumPy and Pandas. NumPy is a powerful library for numerical computing, offering support for multi-dimensional arrays and matrices, along with a variety of mathematical functions to perform operations on these arrays. Pandas is built on top of NumPy and makes data manipulation and analysis more convenient through its DataFrame object, which is essentially a table with labeled axes (rows and columns). Pandas provide intuitive data manipulation operations such as grouping, merging, filtering, and reshaping data.
"""

# Example: # Example 1: Creating a NumPy array
# Example: import numpy as np
# Example: array = np.array([1, 2, 3])
# Example: print(array)
# Example: 
# Example: # Example 2: Performing element-wise operations with NumPy
# Example: import numpy as np
# Example: array1 = np.array([1, 2, 3])
# Example: array2 = np.array([4, 5, 6])
# Example: sum_array = array1 + array2
# Example: print(sum_array)
# Example:  # Expected Output: [5 7 9]
# Example: 
# Example: # Example 3: Creating a Pandas DataFrame
# Example: import pandas as pd
# Example: data = {'name': ['Alice', 'Bob', 'Charlie'], 'age': [25, 32, 37]}
# Example: df = pd.DataFrame(data)
# Example: print(df)
# Example: 
# Example: # Example 4: Selecting data in a DataFrame
# Example: print(df['age'])  # Get the 'age' column
# Example: print(df.iloc[1]) # Get the second row
# Example: 
# Example: # Example 5: Using DataFrame filtering
# Example: older_than_30 = df[df['age'] > 30]
# Example: print(older_than_30)
# Exercise: # Exercise 1: Create a NumPy array of 10 zeroes.
# Exercise: 
# Exercise: # Exercise 2: Add two NumPy arrays of the same dimension.
# Exercise: 
# Exercise: # Exercise 3: Create a Pandas DataFrame using a dictionary and select a specific column.
# Exercise: 
# Exercise: # Exercise 4: Filter rows in a DataFrame where a certain column value is greater than a specific threshold.
# Exercise: 
# Exercise: # Exercise 5: Use the Pandas .groupby() function to group data by a specific column and calculate the mean.
# Additional Resource: NumPy User Guide: https://numpy.org/doc/stable/user/index.html
# Additional Resource: NumPy Quickstart tutorial: https://numpy.org/doc/stable/user/quickstart.html
# Additional Resource: 10 Minutes to Pandas: https://pandas.pydata.org/pandas-docs/stable/user_guide/10min.html
# Additional Resource: Pandas Getting Started: https://pandas.pydata.org/docs/getting_started/index.html
# Additional Resource: Data Analysis with Python (Coursera Course): https://www.coursera.org/learn/data-analysis-with-python