# Data Visualization
"""
Data Visualization refers to the techniques used to communicate data or information by encoding it as visual objects (e.g., points, lines, or bars) contained in graphics. In Python, data visualization is commonly done using libraries such as Matplotlib, Seaborn, and Plotly, which provide a high-level interface for drawing attractive and informative statistical graphics. The primary goal of data visualization is to clearly and efficiently communicate information through the visual representation of data. It involves the creation of graphical representations of data to uncover patterns, correlations, and trends that may go unnoticed in text-based data.
"""

# Example: # Example 1: Basic Line Plot using Matplotlib
import matplotlib.pyplot as plt
x = [0, 1, 2, 3, 4]
y = [0, 1, 4, 9, 16]
plt.plot(x, y)
plt.title('Basic Line Plot')
plt.xlabel('X Axis')
plt.ylabel('Y Axis')
plt.show()
# Example: # Example 2: Bar Chart using Matplotlib
import matplotlib.pyplot as plt
categories = ['A', 'B', 'C', 'D']
values = [10, 20, 15, 30]
plt.bar(categories, values)
plt.title('Basic Bar Chart')
plt.xlabel('Categories')
plt.ylabel('Values')
plt.show()
# Example: # Example 3: Scatter Plot using Matplotlib
import matplotlib.pyplot as plt
x = [5, 7, 8, 5, 6, 7, 9, 2, 3]
y = [99, 86, 87, 88, 100, 86, 103, 94, 77]
plt.scatter(x, y)
plt.title('Basic Scatter Plot')
plt.xlabel('X Axis')
plt.ylabel('Y Axis')
plt.show()
# Example: # Example 4: Histogram using Matplotlib
import matplotlib.pyplot as plt
values = [72, 88, 93, 85, 77, 94, 79, 84, 90]
plt.hist(values, bins=5)
plt.title('Basic Histogram')
plt.xlabel('Value Range')
plt.ylabel('Frequency')
plt.show()
# Example: # Example 5: Box Plot using Seaborn
import seaborn as sns
values = [72, 88, 93, 85, 77, 94, 79, 84, 90]
sns.boxplot(values)
plt.title('Basic Box Plot')
plt.xlabel('Values')
plt.show()
# Exercise: 1. Create a line plot using Matplotlib to visualize the function y = x^2 for x values ranging from -10 to 10.
# Exercise: 2. Using Matplotlib, create a bar chart to compare the average monthly temperature for New York, London, and Sydney.
# Exercise: 3. Generate a scatter plot of sample data to visualize a positive correlation between two sets of numbers using either Matplotlib or Seaborn.
# Exercise: 4. Use Matplotlib to create a histogram that shows the distribution of ages in a classroom.
# Exercise: 5. Use Seaborn to create a box plot comparing the exam scores of two different classes.
# Additional Resource: 1. Matplotlib documentation (https://matplotlib.org/3.1.1/contents.html)
# Additional Resource: 2. Seaborn documentation (http://seaborn.pydata.org/)
# Additional Resource: 3. Effective Data Visualization: The Right Chart for the Right Data by Stephanie Evergreen
# Additional Resource: 4. 'Python for Data Visualization' course on Coursera
# Additional Resource: 5. Plotly documentation (https://plotly.com/python/)