# Variables and Basic Data Types
"""
In Python, variables are names attached to particular objects. You can think of them as labels that you can stick onto something, so you can refer to it easily later on. You don't need to declare or specify the data type to use a variable, as Python is dynamically typed. Basic data types in Python include integers (int), floating-point numbers (float), strings (str), and booleans (bool). Integers are whole numbers that can be positive or negative. Floating-point numbers are real numbers that contain a decimal point. Strings are sequences of characters enclosed in quotes. Booleans represent truth values and can be either True or False.
"""

# Example: # Example of integer variable
x = 10
print(x)  # Output: 10
# Example: # Example of float variable
y = 3.14
print(y)  # Output: 3.14
# Example: # Example of string variable
name = 'Alice'
print(name)  # Output: Alice
# Example: # Example of boolean variable
is_student = True
print(is_student)  # Output: True
# Example: # Multiple assignment
a, b, c = 5, 3.2, 'Hello'
print(a)  # Output: 5
print(b)  # Output: 3.2
print(c)  # Output: Hello
# Exercise: 1. Create an integer variable named 'age' and set it to your age.
# Exercise: 2. Create a float variable named 'height' to represent someone's height in meters (e.g., 1.75).
# Exercise: 3. Create a string variable named 'greeting' and assign it a greeting phrase like 'Hello, World!'.
# Exercise: 4. Create a boolean variable named 'is_python_fun' and set it to True if you think Python is fun or False otherwise.
# Exercise: 5. Create variables of different types and then use the type() function to check their data types.
# Additional Resource: https://docs.python.org/3/tutorial/introduction.html#using-python-as-a-calculator
# Additional Resource: https://realpython.com/python-variables/
# Additional Resource: https://www.w3schools.com/python/python_datatypes.asp
# Additional Resource: https://docs.python.org/3/library/stdtypes.html#numeric-types-int-float-complex