# Control Flow (if, else, loops)
"""
Control flow in Python refers to the order in which statements are executed at runtime based on conditional logic and loops. The 'if' statement allows for conditional execution, executing blocks of code only when certain conditions are met. The 'else' clause can be added to an 'if' statement to define an alternative block of code that is executed when the condition is false. Loops, such as 'while' and 'for', allow for repeating a block of code multiple times. The 'while' loop repeats as long as a specified condition is true, and the 'for' loop iterates over a sequence (which could be a list, a tuple, or a string, among other iterable objects).
"""

# Example: # Using if to perform a condition check
# Example: age = 18
# Example: if age >= 18:
# Example:     print('You are an adult.')
# Example: 
# Example: # Adding else to handle the alternate condition
# Example: age = 15
# Example: if age >= 18:
# Example:     print('You are an adult.')
# Example: else:
# Example:     print('You are not yet an adult.')
# Example: 
# Example: # Using a while loop to repeat a block of code
# Example: count = 0
# Example: while count < 5:
# Example:     print('The count is:', count)
# Example:     count += 1
# Example: 
# Example: # Using a for loop to iterate over a list
# Example: fruits = ['apple', 'banana', 'cherry']
# Example: for fruit in fruits:
# Example:     print('Current fruit:', fruit)
# Exercise: 1. Write an if-else statement that will print 'Even number' if a variable `x` is even, and 'Odd number' if `x` is odd.
# Exercise: 2. Create a for loop that prints all the numbers from 1 to 10 inclusive.
# Exercise: 3. Write a while loop that sums up all the elements from a given list `numbers` until the sum reaches 100 or there are no more numbers to add.
# Exercise: 4. Using a for loop and an if statement, print out all the elements from a list `my_list` that are greater than 50.
# Exercise: 5. Write a program that uses a nested if to determine if a number is positive and even, only positive, only even, or neither.
# Additional Resource: Python official documentation on control flow: https://docs.python.org/3/tutorial/controlflow.html
# Additional Resource: W3Schools Python Conditional Statements: https://www.w3schools.com/python/python_conditions.asp
# Additional Resource: Real Python article on loops and iteration: https://realpython.com/python-for-loop/
# Additional Resource: Codecademy Learn Python 2 - Control Flow: https://www.codecademy.com/learn/learn-python/modules/learn-python-control-flow
# Additional Resource: Geeks for Geeks Python Programming Language - Control Flow: https://www.geeksforgeeks.org/python-programming-language-control-flow/