# Object-Oriented Programming
"""
Object-Oriented Programming (OOP) is a programming paradigm based on the concept of 'objects', which can contain data, in the form of fields (often known as attributes or properties), and code, in the form of procedures (often known as methods). A feature of objects is that an object's procedures can access and often modify the data fields of the object with which they are associated. OOP uses classes as blueprints for creating objects. Basic principles of OOP include encapsulation (data hiding), inheritance (deriving new classes from existing ones), and polymorphism (using a single interface to represent different types).
"""

# Example: # Define a simple class with a method
# Example: class Dog:
# Example:     def __init__(self, name, age):
# Example:         self.name = name
# Example:         self.age = age
# Example:     def bark(self):
# Example:         return f'{self.name} says woof!'
# Example: 
# Example: # Instantiate an object of the Dog class
# Example: my_dog = Dog('Buddy', 4)
# Example: print(my_dog.bark())  # Output: Buddy says woof!
# Example: 
# Example: # Example of inheritance
# Example: class GoldenRetriever(Dog):
# Example:     def fetch(self, item):
# Example:         return f'{self.name} fetched the {item}!'
# Example: 
# Example: # Instantiate a GoldenRetriever object
# Example: my_golden = GoldenRetriever('Lucy', 3)
# Example: print(my_golden.fetch('ball'))  # Output: Lucy fetched the ball!
# Example: print(my_golden.bark())  # Inherited method from Dog class - Output: Lucy says woof!
# Example: 
# Example: # Example of polymorphism
# Example: class Cat:
# Example:     def __init__(self, name):
# Example:         self.name = name
# Example:     def speak(self):
# Example:         return f'{self.name} says meow!'
# Example: 
# Example: # Function that demonstrates polymorphism
# Example: def animal_sound(animal):
# Example:     print(animal.speak())
# Example: 
# Example: my_cat = Cat('Whiskers')
# Example: # Even though Dog and Cat are different classes,
# Example: # the function animal_sound works on instances of both
# Example: # because they implement the expected interface, in this case, a speak method.
# Example: animal_sound(my_dog)  # Output: Buddy says woof!
# Example: animal_sound(my_cat)  # Output: Whiskers says meow!
# Exercise: 1. Define a class called `Car` with properties like `make`, `model`, and `year`. Include a method that displays the full name of the car.
# Exercise: 2. Create a subclass of the `Car` class called `ElectricCar` that has a battery_size attribute and a method to display the battery size.
# Exercise: 3. Implement overriding of a parent class method in a subclass to demonstrate how a child class can change the behavior of functions from the parent class.
# Exercise: 4. Create objects from the `Car` and `ElectricCar` classes and call their methods to ensure they are working.
# Exercise: 5. Write a function `compare_cars` that takes two instances of the `Car` class and compares their year. The function should report which car is newer or if they are the same age.
# Additional Resource: https://docs.python.org/3/tutorial/classes.html
# Additional Resource: https://realpython.com/python3-object-oriented-programming/
# Additional Resource: https://www.programiz.com/python-programming/object-oriented-programming
# Additional Resource: https://en.wikipedia.org/wiki/Object-oriented_programming