# Advanced Topics (Decorators, Generators)
"""
In Python, decorators are a way to modify or enhance functions and methods without changing their original code. They are represented by the '@' symbol and are placed directly above a function definition. A decorator is itself a function that takes another function as an argument and returns yet another function, which can add some functionality to the original. Generators are a type of iterable, like lists or tuples, except that they dont store their contents in memory. Instead, they generate values on the fly and can be used to create sequences of values without creating a full-fledged list. This is done with the 'yield' keyword, which keeps state between executions.
"""

# Example: # Example of a simple decorator that adds a print statement before the function call

# Example: def my_decorator(func):

# Example:     def wrapper():

# Example:         print("Something is happening before the function is called.")

# Example:         func()

# Example:         print("Something is happening after the function is called.")

# Example:     return wrapper

# Example: @my_decorator

# Example: def say_hello():

# Example:     print("Hello!")

# Example: # say_hello now has additional functionality

# Example: say_hello()

# Example: 

# Example: # Example of a generator function

# Example: def countdown(num):

# Example:     while num > 0:

# Example:         yield num

# Example:         num -= 1

# Example: # Use the generator

# Example: for count in countdown(5):

# Example:     print(count)

# Exercise: 1. Write a decorator 'log_function_call' that logs when a function is called and what arguments were used.
# Exercise: 2. Modify the 'log_function_call' decorator so that it also logs the time it took to execute the function.
# Exercise: 3. Create a generator 'fibonacci' that generates the sequence of Fibonacci numbers indefinitely.
# Exercise: 4. Write a decorator 'type_check' that ensures the first argument to a function is of the specified type. If it is not, print an error message.
# Additional Resource: Real Python's guide on decorators: https://realpython.com/primer-on-python-decorators/
# Additional Resource: Official Python documentation on decorators: https://docs.python.org/3/glossary.html#term-decorator
# Additional Resource: Real Python's deep dive into Python generators: https://realpython.com/introduction-to-python-generators/
# Additional Resource: Official Python documentation on generators: https://docs.python.org/3/tutorial/classes.html#generators