# Data Visualization
"""
Data visualization is the graphical representation of information and data. By using visual elements like charts, graphs, and maps, data visualization tools provide an accessible way to see and understand trends, outliers, and patterns in data. In Python, libraries such as Matplotlib, Seaborn, and Plotly are popular for creating data visualizations. These libraries offer a wide range of options for plotting data in different formats, enabling the user to create both static and interactive visualizations. A good grasp of data visualization is essential for data analysis and is often used for exploratory data analysis (EDA), to communicate insights, or to support decision-making.
"""

# Example: # Example 1: Basic line chart using Matplotlib
# Example: import matplotlib.pyplot as plt
# Example: years = [2010, 2011, 2012, 2013, 2014, 2015]
# Example: value = [100, 120, 90, 200, 80, 130]
# Example: plt.plot(years, value)
# Example: plt.title('Basic Line Chart')
# Example: plt.xlabel('Year')
# Example: plt.ylabel('Value')
# Example: plt.show()
# Example: 
# Example: # Example 2: Bar chart using Seaborn
# Example: import seaborn as sns
# Example: names = ['A', 'B', 'C', 'D']
# Example: values = [10, 23, 15, 18]
# Example: sns.barplot(x=names, y=values)
# Example: plt.title('Bar Chart')
# Example: plt.show()
# Example: 
# Example: # Example 3: Scatter plot with regression line
# Example: import numpy as np
# Example: np.random.seed(8)
# Example: x = np.random.randn(50)
# Example: y = 2 * x + np.random.randn(50)
# Example: sns.regplot(x=x, y=y)
# Example: plt.title('Scatter plot with regression line')
# Example: plt.show()
# Exercise: 1. Using Matplotlib, create a pie chart that represents data from a list of 5 different sectors and their respective market share percentages.
# Exercise: 2. With Seaborn, generate a heatmap that visualizes a correlation matrix for a given DataFrame.
# Exercise: 3. Use Plotly to create an interactive scatter plot allowing the user to see details on hover for a data set with at least two numerical columns.
# Exercise: 4. Create a histogram of a normal distribution with 1000 random values using Matplotlib and customize its appearance (color, number of bins, transparency, etc.).
# Exercise: 5. Make a line chart with two separate lines (representing different data series), add a legend, and customize the markers and line styles using Seaborn.
# Additional Resource: Python Data Science Handbook by Jake VanderPlas: https://jakevdp.github.io/PythonDataScienceHandbook/
# Additional Resource: Matplotlib documentation: https://matplotlib.org/stable/contents.html
# Additional Resource: Seaborn documentation: https://seaborn.pydata.org/
# Additional Resource: Plotly Python Graphing Library: https://plotly.com/python/
# Additional Resource: Data Visualization with Python and JavaScript by Kyran Dale: https://www.amazon.com/Data-Visualization-Python-JavaScript-Transform/dp/1491920513